#!/bin/sh
#
SUDO=sudo
PCITOOL=/usr/sbin/pcitool

CPU_START=0
CPU_OFF=128
PSET_OFF=64

set -A nexus_arr 300 300 300 300 3c0 3c0 380 380
set -A inst_arr    0   1   2   3   4   5   6  7
set -A inst_start  0   0   8   0 136   8 136  0
set -A tgt_cnt     0   0   4   0   4   4   4  0

set -A inst_tgt    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
for X in 2 6 5 4
do
        # Get the MSI list for this device for Driver txns
	I=${inst_arr[$X]}
        echo Configuring intrs for ixgbe#${I}
	NEXUS=/`ls -l /dev/ixgbe${I} | awk '{print $11}' | cut -d / -f3`
	echo $NEXUS
        ino_cnt=`$SUDO $PCITOOL $NEXUS -i | grep -c ixgbe#${I}`
        set -A ino_arr `$SUDO $PCITOOL $NEXUS -i | grep ixgbe#${I} | sort +0.10 | awk '{print $3}'`

	# Create CPU targets
	T=15
	TC=${tgt_cnt[$X]}
	TGT=${inst_start[$X]}
	while [ $T -ge 0 ]; do
		inst_tgt[$T]=`printf "%x" $TGT`
		TC=`expr $TC - 1`
		TGT=`expr $TGT + 1`
		if [ $TC -eq 0 ]; then
			TC=${tgt_cnt[$X]}
			TGT=${inst_start[$X]}
		fi
		T=`expr $T - 1`
	done

        echo "Targeted cpus: "
	T=0
	while [ $T -lt 16 ]; do
		echo $T: "${inst_tgt[$T]} -> ${ino_arr[$T]}"
		T=`expr $T + 1`
	done

        # Program the CPU binding for this MSI
        i=0
        while [ $i -lt $ino_cnt ] ; do
                $SUDO $PCITOOL $NEXUS -m ${ino_arr[$i]} -w ${inst_tgt[$i]}
                i=`expr $i + 1`
        done

done

